/** @file
* PURPOSE: File contains the whole program
* Call by Value, Call by Reference
* @author Daniel Hasemann
* October 31nd, 2005
*************************************************/

#include <stdio.h>
#include <stdlib.h>

/** @brief main program
    *
    * Call by Value, Call by Reference
    * Difference between cbv,cbr
    @author Daniel Hasemann
    *October 31nd, 2005
    ******************************************/

int callbyvalue(int);
void callbyreference(int*);

int main()
{
    int ivar;
    int ivar2;
    
  
  
    ivar=1;
    ivar2=1;
  
  
    
    printf("\nCall by Value=%d",callbyvalue(ivar));
  
    callbyreference(&ivar2);
    printf("\nCall by Reference=%d\n",ivar2);
  
    system("PAUSE");	
    return 0;
}

/** @brief callbyvalue
    *
    * returns x
    @author Daniel Hasemann
    @param nothing
    @return x is an integer
    @see main()
    *October 31nd, 2005
    ******************************************/
    
int callbyvalue(int x)
{
    x=2;
    return x;
}

/** @brief callbyreference
    *
    @author Daniel Hasemann
    @param x is an integer
    @see main()
    *October 31nd, 2005
    ******************************************/

void callbyreference(int *x)
{
    *x=2;    
}
