/** @file
* PURPOSE: File contains the whole program
* Storage Allocation
* @author Daniel Hasemann
* October 31nd, 2005
*************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

void bubble(int*,int);

/** @brief main program        
    *  
    * Defines pointer,vars and calls bubbleshort
    @author Daniel Hasemann
    *November 1st, 2005
    ******************************************/

int main(void)
{
    
    int *parray;        
    int *pwrite;        
    int size =100;        
    int count;
    
    parray = (int *)malloc(size*sizeof(int));
    if(!parray)                                //Bordercheck of heap!
    {
        printf("\nERROR IN SIZE OF HEAP! CANNOT SAVE %d BYTE(S)\n\n",(size*sizeof(int)));
        system("PAUSE");
        exit(1);
    } 
    
    pwrite=parray;
    
    for(count = size; count >=1; count--)
    {
        *pwrite = count;
        pwrite++;
    }
    
    pwrite=parray;                               //Adress reset from pwrite
    
    for(count = 1; count <= size; count++)
    {
        printf("Pwrite[%d] Value %d\n",count,*pwrite);
        pwrite++;
    }
  
    bubble(parray,count);
    
    system("PAUSE");
    
    pwrite=parray;                                //Adress reset from pwrite
    
    for(count = 1; count <= size; count++)
    {
        printf("Pwrite[%d] Value %d\n",count,*pwrite);
        pwrite++;
    }
  
    free(parray);
  
  
    system("PAUSE");	
    return 0;
 
}

/** @brief bubble        
    *  
    * Bubblesort! The worst program to sort variables! 1/2(n-n) structur
    * n=quantity of variables to sort
    @param *items is an integer
    @param count is an integer
    @see main()
    @author Daniel Hasemann
    *November 1st, 2005
    ******************************************/
    
void bubble(int *items, int count)
{
  int a;
  int b;
  int temp;
  int *point;
  
  point = items;
  
  for(a = 1; a < count; ++a)
  {
    items = point;
    for(b = 0; b < count; b++)
    {
      if(*items > *(items + 1))
        {
          temp = *items;
          *items = *(items + 1);
          *(items + 1) = temp;
        }
        items++;
    }
  }
}
