/** @file
* PURPOSE: File contains the whole program
* Imagin figures
* @author Daniel Hasemann
* October 22nd, 2005
*************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>


float Phase(int,int);

float Betrag(int,int);

/** @brief main program        
    *  
    * Defines vars, prints text on screen
    @author Daniel Hasemann
    *October 22nd, 2005
    ******************************************/
    
int main(int argc, char *argv[])
{
  clrscr();
  
  int a;                        //real part
  int b;                        //imagin part
    
  gotoxy(1,1);
  printf("z=a+jb\n\n");
  printf("Wert fuer Variable a eingeben:");
  scanf("%d",&a);
  gotoxy(1,4);
  printf("Wert fuer Variable b eingeben:");
  scanf("%d",&b);
  gotoxy(1,6);
  printf("z=%d+j%d",a,b);
  gotoxy(1,8);
  printf("Phase=%f",Phase(a,b));
  gotoxy(1,10);
  printf("Betrag=%f",Betrag(a,b));
  
  getch();
  
  return 0;

}
/** @brief Phase        
    *  
    * calculates the phase from the vector 
    @param a is an integer
    @param b is an integer
    @return d is a float
    @see main()
    @author Daniel Hasemann
    *October 22nd, 2005
    ******************************************/   

float Phase(int a,int b)
    {
        float c;
        float d;
        
        c=atan2 (b,a);                  //atan has got problems about negative figures
        d=c*360/(2*M_PI);               //calculates value in degree
        
        return d;
    } 

/** @brief Bertag        
    *  
    * calculates the length from the vector 
    @param a is an integer
    @param b is an integer
    @return d is a float
    @see main()
    @author Daniel Hasemann
    *October 22nd, 2005
    ******************************************/

float Betrag (int a, int b)
    {
        float d;
        
        d=sqrt((a*a+b*b));
    
        return d;
    }
    
