/** @file dllmain.c
*PURPOSE: File contains ssolution
* 
*@author Daniel Hasemann
*@version 1.2
*@date December 16th, 2005
*************************************************/

#include "dll.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

#define MAX_SIZE 12

/** @brief ssolution    
*
*This dll file saves the solution on HDD. Char array cfilename includes the
*filename where the solution should be saved. If the filename is invalid
*a message tells the filename cannot write.
*@param iboard is an integer array
*@param iblength is an integer
*@param isolutions is an integer
*@param *iauthor is an integer pointer
*@param cfilename is a char array
*@see calculate()
*@author Daniel Hasemann
*@date December 16th, 2005
***************************************/

DLLIMPORT void ssolution(int iboard[MAX_SIZE][MAX_SIZE],int iblength,int isolutions,int *iauthor ,char cfilename[100])
{
    FILE *pfile;
    int ik;
    int ii;
   
    pfile=fopen(cfilename,"a");
    if(!pfile)
    {
        gotoxy(3,16);
        printf("Filename Error!");
        gotoxy(3,17);
        printf("Can%ct write [%s]",39,cfilename);     //ascii 39=
    }
    else
    {
        
        if(!*iauthor)                                 //text-file-header
        {
            fprintf(pfile,"%d-QUEENS-PROBLEM\nAuthor : Daniel Hasemann\nVersion : 1.2\n\n",iblength);
            *iauthor=1;
        }
        
        for(ii=0;ii<iblength;ii++)
        {   
            for(ik=0;ik<iblength;ik++)
            {
                if(iboard[ik][ii])
                {
                    fprintf(pfile,"[%c%d]",ii+65,iblength-ik); //prints solution in file
                }    
               
            }
        }
        fprintf(pfile," >>>Solution [%d] ",isolutions);        //prints number of solution in file
        fprintf(pfile,"\n");                                   //next line
        fclose(pfile);
    }
}


BOOL APIENTRY DllMain (HINSTANCE hInst     /* Library instance handle. */ ,
                       DWORD reason        /* Reason this function is being called. */ ,
                       LPVOID reserved     /* Not used. */ )
{
    switch (reason)
    {
      case DLL_PROCESS_ATTACH:
        break;

      case DLL_PROCESS_DETACH:
        break;

      case DLL_THREAD_ATTACH:
        break;

      case DLL_THREAD_DETACH:
        break;
    }


    return TRUE;
}
